% Author: Diego & Yamand
% Date: 09/05/2014

% 0 == vacio, 1 == jug1 (Jugador), 2 == jug2 (Maquina)

%Tablero inicial
% tablero([0,0,0,0,0,0,0,0]    Cuadrado exterior
%        ,[0,0,0,0,0,0,0,0]   Cuadrado intermedio
%        ,[0,0,0,0,0,0,0,0]). Cuadrado interior

% Limpia la pantalla de comandos
:- module(molinero,
        [ molinero/0,
	  rivalSinFichas/1,
	  rivalBloqueado/2,
	  moves/3,
	  put/8,
	  opponent/1,
	  me/1,
	  phase/1,
	  fichasEnPuntosMedios/3,
	  unaFichaEnCadaNivel/2,
	  molinoFormado/3,
	  longitud/2
        ]).

:- use_module(algorithms,
        [ minimax/6            % The minimax algorithm
        ]).
		
% referente a la maquina
me(2).
opponent(1).

:- dynamic tablero/3,phase/1,bloqueado/1,lista1/1,lista2/1.

limpia:-
        format('~c~s~c~s',[0x1b,"[H",0x1b,"[2J"]).

iesimo(X,0,[X|_]).
iesimo(X,N,[_|Xs]):- N1 is N-1, iesimo(X,N1,Xs).

dibujaTablero:-
        limpia,
        tablero([S0,S1,S2,S3,S4,S5,S6,S7]
                ,[M0,M1,M2,M3,M4,M5,M6,M7]
                ,[I0,I1,I2,I3,I4,I5,I6,I7]),
        write(S0),write('     '),write(S1),write('     '),write(S2),                    write('   '),write(a),write('     '),write(b),write('     '),write(c),nl,
        write('  '),write(M0),write('   '),write(M1),write('   '),write(M2),write('  '),write('   '),write('  '),write(i),write('   '),write(j),write('   '),write(k),write('  '),nl,
        write('    '),write(I0),write(' '),write(I1),write(' '),write(I2),write('    '),write('   '),write('    '),write(q),write(' '),write(r),write(' '),write(s),write('    '),nl,

        write(S7),write(' '),write(M7),write(' '),write(I7),
        write('   '),
        write(I3),write(' '),write(M3),write(' '),write(S3),                            write('   '),write(h),write(' '),write(p),write(' '),write(x),
		                                                                                write('   '),
		                                                                                write(t),write(' '),write(l),write(' '),write(d),nl,

        write('    '),write(I6),write(' '),write(I5),write(' '),write(I4),write('    '),write('   '),write('    '),write(w),write(' '),write(v),write(' '),write(u),write('    '),nl,
        write('  '),write(M6),write('   '),write(M5),write('   '),write(M4),write('  '),write('   '),write('  '),write(o),write('   '),write(n),write('   '),write(m),write('  '),nl,
        write(S6),write('     '),write(S5),write('     '),write(S4),                    write('   '),write(g),write('     '),write(f),write('     '),write(e),nl,nl.

% quitarFichaTablero(+,+,+,-) Quitar la ficha del jugador Jug en la posicin Letra
quitarFichaTablero([S,M,I],Letra,Jug,[Sc,Mc,Ic]):-
        [S0,S1,S2,S3,S4,S5,S6,S7] = S,
        [M0,M1,M2,M3,M4,M5,M6,M7] = M,
        [I0,I1,I2,I3,I4,I5,I6,I7] = I,
        % switch de prolog
        X = Letra,
        (
        X = a, (S0 = 0 | Jug = S0), Sc =[0,S1,S2,S3,S4,S5,S6,S7],Mc = M, Ic = I;
        X = b, (S1 = 0 | Jug = S1), Sc =[S0,0,S2,S3,S4,S5,S6,S7],Mc = M, Ic = I;
        X = c, (S2 = 0 | Jug = S2), Sc =[S0,S1,0,S3,S4,S5,S6,S7],Mc = M, Ic = I;
        X = d, (S3 = 0 | Jug = S3), Sc =[S0,S1,S2,0,S4,S5,S6,S7],Mc = M, Ic = I;
        X = e, (S4 = 0 | Jug = S4), Sc =[S0,S1,S2,S3,0,S5,S6,S7],Mc = M, Ic = I;
        X = f, (S5 = 0 | Jug = S5), Sc =[S0,S1,S2,S3,S4,0,S6,S7],Mc = M, Ic = I;
        X = g, (S6 = 0 | Jug = S6), Sc =[S0,S1,S2,S3,S4,S5,0,S7],Mc = M, Ic = I;
        X = h, (S7 = 0 | Jug = S7), Sc =[S0,S1,S2,S3,S4,S5,S6,0],Mc = M, Ic = I;
        X = i, (M0 = 0 | Jug = M0), Mc =[0,M1,M2,M3,M4,M5,M6,M7],Sc = S, Ic = I;
        X = j, (M1 = 0 | Jug = M1), Mc =[M0,0,M2,M3,M4,M5,M6,M7],Sc = S, Ic = I;
        X = k, (M2 = 0 | Jug = M2), Mc =[M0,M1,0,M3,M4,M5,M6,M7],Sc = S, Ic = I;
        X = l, (M3 = 0 | Jug = M3), Mc =[M0,M1,M2,0,M4,M5,M6,M7],Sc = S, Ic = I;
        X = m, (M4 = 0 | Jug = M4), Mc =[M0,M1,M2,M3,0,M5,M6,M7],Sc = S, Ic = I;
        X = n, (M5 = 0 | Jug = M5), Mc =[M0,M1,M2,M3,M4,0,M6,M7],Sc = S, Ic = I;
        X = o, (M6 = 0 | Jug = M6), Mc =[M0,M1,M2,M3,M4,M5,0,M7],Sc = S, Ic = I;
        X = p, (M7 = 0 | Jug = M7), Mc =[M0,M1,M2,M3,M4,M5,M6,0],Sc = S, Ic = I;
        X = q, (I0 = 0 | Jug = I0), Ic =[0,I1,I2,I3,I4,I5,I6,I7],Sc = S, Mc = M;
        X = r, (I1 = 0 | Jug = I1), Ic =[I0,0,I2,I3,I4,I5,I6,I7],Sc = S, Mc = M;
        X = s, (I2 = 0 | Jug = I2), Ic =[I0,I1,0,I3,I4,I5,I6,I7],Sc = S, Mc = M;
        X = t, (I3 = 0 | Jug = I3), Ic =[I0,I1,I2,0,I4,I5,I6,I7],Sc = S, Mc = M;
        X = u, (I4 = 0 | Jug = I4), Ic =[I0,I1,I2,I3,0,I5,I6,I7],Sc = S, Mc = M;
        X = v, (I5 = 0 | Jug = I5), Ic =[I0,I1,I2,I3,I4,0,I6,I7],Sc = S, Mc = M;
        X = w, (I6 = 0 | Jug = I6), Ic =[I0,I1,I2,I3,I4,I5,0,I7],Sc = S, Mc = M;
        X = x, (I7 = 0 | Jug = I7), Ic =[I0,I1,I2,I3,I4,I5,I6,0],Sc = S, Mc = M;
		false ) -> true ; false.

% colocaFicha(+,+,+,-) Coloca la ficha del jugador Jug en la posicion Letra
colocaFicha([S,M,I],Letra,Jug,[Sc,Mc,Ic]):-

        [S0,S1,S2,S3,S4,S5,S6,S7] = S,
        [M0,M1,M2,M3,M4,M5,M6,M7] = M,
        [I0,I1,I2,I3,I4,I5,I6,I7] = I,
        % switch de prolog
        X = Letra,
        (
        X = a, S0 = 0, Sc =[Jug,S1,S2,S3,S4,S5,S6,S7],Mc = M, Ic = I;
        X = b, S1 = 0, Sc =[S0,Jug,S2,S3,S4,S5,S6,S7],Mc = M, Ic = I;
        X = c, S2 = 0, Sc =[S0,S1,Jug,S3,S4,S5,S6,S7],Mc = M, Ic = I;
        X = d, S3 = 0, Sc =[S0,S1,S2,Jug,S4,S5,S6,S7],Mc = M, Ic = I;
        X = e, S4 = 0, Sc =[S0,S1,S2,S3,Jug,S5,S6,S7],Mc = M, Ic = I;
        X = f, S5 = 0, Sc =[S0,S1,S2,S3,S4,Jug,S6,S7],Mc = M, Ic = I;
        X = g, S6 = 0, Sc =[S0,S1,S2,S3,S4,S5,Jug,S7],Mc = M, Ic = I;
        X = h, S7 = 0, Sc =[S0,S1,S2,S3,S4,S5,S6,Jug],Mc = M, Ic = I;
        X = i, M0 = 0, Mc =[Jug,M1,M2,M3,M4,M5,M6,M7],Sc = S, Ic = I;
        X = j, M1 = 0, Mc =[M0,Jug,M2,M3,M4,M5,M6,M7],Sc = S, Ic = I;
        X = k, M2 = 0, Mc =[M0,M1,Jug,M3,M4,M5,M6,M7],Sc = S, Ic = I;
        X = l, M3 = 0, Mc =[M0,M1,M2,Jug,M4,M5,M6,M7],Sc = S, Ic = I;
        X = m, M4 = 0, Mc =[M0,M1,M2,M3,Jug,M5,M6,M7],Sc = S, Ic = I;
        X = n, M5 = 0, Mc =[M0,M1,M2,M3,M4,Jug,M6,M7],Sc = S, Ic = I;
        X = o, M6 = 0, Mc =[M0,M1,M2,M3,M4,M5,Jug,M7],Sc = S, Ic = I;
        X = p, M7 = 0, Mc =[M0,M1,M2,M3,M4,M5,M6,Jug],Sc = S, Ic = I;
        X = q, I0 = 0, Ic =[Jug,I1,I2,I3,I4,I5,I6,I7],Sc = S, Mc = M;
        X = r, I1 = 0, Ic =[I0,Jug,I2,I3,I4,I5,I6,I7],Sc = S, Mc = M;
        X = s, I2 = 0, Ic =[I0,I1,Jug,I3,I4,I5,I6,I7],Sc = S, Mc = M;
        X = t, I3 = 0, Ic =[I0,I1,I2,Jug,I4,I5,I6,I7],Sc = S, Mc = M;
        X = u, I4 = 0, Ic =[I0,I1,I2,I3,Jug,I5,I6,I7],Sc = S, Mc = M;
        X = v, I5 = 0, Ic =[I0,I1,I2,I3,I4,Jug,I6,I7],Sc = S, Mc = M;
        X = w, I6 = 0, Ic =[I0,I1,I2,I3,I4,I5,Jug,I7],Sc = S, Mc = M;
        X = x, I7 = 0, Ic =[I0,I1,I2,I3,I4,I5,I6,Jug],Sc = S, Mc = M;
		false ) -> true ; false.

% Acierta en caso de que la letra sea del tipo de la ficha (vale para
% los 3 valores posibles de ficha: 0, 1 ,2)
% tipoFicha(+,+,+)
tipoFicha([S,M,I],Letra,Ficha):-
	%tablero(S,M,I),
        [S0,S1,S2,S3,S4,S5,S6,S7] = S,
        [M0,M1,M2,M3,M4,M5,M6,M7] = M,
        [I0,I1,I2,I3,I4,I5,I6,I7] = I,
        % switch de prolog
        X = Letra,
        (
        X = a, Ficha = S0;
        X = b, Ficha = S1;
        X = c, Ficha = S2;
        X = d, Ficha = S3;
        X = e, Ficha = S4;
        X = f, Ficha = S5;
        X = g, Ficha = S6;
        X = h, Ficha = S7;
        X = i, Ficha = M0;
        X = j, Ficha = M1;
        X = k, Ficha = M2;
        X = l, Ficha = M3;
        X = m, Ficha = M4;
        X = n, Ficha = M5;
        X = o, Ficha = M6;
        X = p, Ficha = M7;
        X = q, Ficha = I0;
        X = r, Ficha = I1;
        X = s, Ficha = I2;
        X = t, Ficha = I3;
        X = u, Ficha = I4;
        X = v, Ficha = I5;
        X = w, Ficha = I6;
        X = x, Ficha = I7;
		false ) -> true ; false.

% concatena(+Letra,+Lista,-NuevaLista)
concatena(Letra,[],[Letra]).
concatena(Letra,Xs,[Letra|Xs]).

% quita(+Letra,+Lista,-NuevaLista)
quita(_,[],[]).
quita(Letra,[Letra|Xs],Xs):-!.
quita(Letra,[X|Xs],[X|Zx]):- quita(Letra,Xs,Zx).

% longitud(+Lista,-Longitud)
longitud([],0).
longitud([_X|Xs],NN):- longitud(Xs,N),NN is N+1.

% bucleMolino(+) Bucle para que el jugador quite una ficha rival cuando ha hecho molino
bucleMolino(Rival):-
		write('Molino! Que ficha quieres quitar?'),nl,
		read(Quitar),
		tablero(S,M,I),
		(tipoFicha([S,M,I],Quitar,Rival),not(molinoFormado([S,M,I],Quitar,Rival)) ->
			quitarFichaTablero([S,M,I],Quitar,Rival,[Sr,Mr,Ir]),
			retract(tablero(_S,_M,_I)),assertz(tablero(Sr,Mr,Ir)),
			lista2(X), quita(Quitar,X,Lista),
			longitud(Lista,Long),
			retract(lista2(_X)),
			assertz(lista2(Lista)),			
			(phase(1) ->   % estamos en la fase de mover piezas
				 ( Long < 3 ->
					assertz(juegoAcabado(true))
				 ;
					true
				 )
			 ;
				true
			 )
		;
			dibujaTablero,
			write('No puedes quitar la ficha '),write(Quitar),nl,
			bucleMolino(Rival)
		).

% colocaFichaJugador(+) Coloca la ficha del usuario en la posicion especificada por parametro.
colocaFichaJugador(NumPiezas,Letra1):-
	tablero(S,M,I),
	(colocaFicha([S,M,I],Letra1,1,[Sr,Mr,Ir]) ->	   
	   retract(tablero(_S,_M,_I)),
	   assertz(tablero(Sr,Mr,Ir)),
	   lista1(X),
	   concatena(Letra1,X,Fichas1),
	   retract(lista1(_X)),
	   assertz(lista1(Fichas1)),	   
		    (molinoFormado([Sr,Mr,Ir],Letra1,1) ->
			 bucleMolino(2)    %hemos hecho un molino, hay que quitar una ficha rival
			;
			 true				% no hemos hecho molino, continua el juego
		    )
	   ;
	   dibujaTablero,
	   write('Posicin no vlida'),nl,
		   mueveJugador(NumPiezas)
	).

% Pone la ficha del jugador 'Jug' de la posicin 'Letra1' en la posicin 'Letra2'
% moverFicha(+,+,+,+)
moverFicha([S,M,I],Letra1,Letra2,Jug):-
	quitarFichaTablero([S,M,I],Letra1,Jug,[Sf,Mf,If]),
	colocaFicha([Sf,Mf,If],Letra2,Jug,[Sf2,Mf2,If2]),
	(Jug is 1 -> lista1(X) ; lista2(X)),
	quita(Letra1,X,Fichas1), concatena(Letra2,Fichas1,Fichas2),
	(Jug is 1 ->
		retract(lista1(_X)),
		assertz(lista1(Fichas2))
	;		
		retract(lista2(_X)),
		assertz(lista2(Fichas2))
	),
	assertz(tablero(Sf2,Mf2,If2)), retract(tablero(S,M,I)).

% mueveFichaJugador(+,+) Hace las comprobaciones necesarias al mover la ficha del jugador.
mueveFichaJugador(NumPiezas,Letra1):-
	read(Letra2),
	tablero(S,M,I),
   (Letra2 \= Letra1,tipoFicha([S,M,I],Letra1,1),tipoFicha([S,M,I],Letra2,0),
   sonAdyacentes(Letra1,Letra2) ->
		moverFicha([S,M,I],Letra1,Letra2,1),
		tablero(Sf2,Mf2,If2),
		(molinoFormado([Sf2,Mf2,If2],Letra2,1) ->
		 bucleMolino(2)    %hemos hecho un molino, hay que quitar una ficha rival
		 ;
		 true				% no hemos hecho molino, continua el juego
		)
	;
		dibujaTablero,
		write('Movimiento no valido'),nl,
		mueveJugador(NumPiezas)
	).

% mueveJugador(+) Determina si el jugador est moviendo segn la primera o la segunda fase del juego.
mueveJugador(NumPiezas):-
	tablero(S,M,I),
	(phase(1),jugadorBloqueado([S,M,I],1) -> assertz(juegoAcabado(true)), assertz(bloqueado(1))
	;
        write('Introduce la posicin:'),nl,
        read(Letra1),
		(Letra1 = salir ->
		   assertz(juegoAcabado(true))
		;
		   (   NumPiezas > 0 ->
				colocaFichaJugador(NumPiezas,Letra1)
			;
				mueveFichaJugador(NumPiezas,Letra1)
		   )
		)
	).

% unSoloAdyacente(L+,Acu?,Letra-).
unSoloAdyacente([],0,_):- false.
unSoloAdyacente([],1,_).
unSoloAdyacente([X|Xs],Acu,Letra):-
		(sonAdyacentes(X,Letra) ->
			(Acu is 1 ->
				!,false
			;
				!,unSoloAdyacente(Xs,1,Letra)
			)
		;
			unSoloAdyacente(Xs,Acu,Letra)
		).

% buscaPeligrosas(+Tablero,+Lista,-ListaDev) Busca todas las fichas con solo una ficha adyacente y que no estn formando un molino
buscaPeligrosas([S,M,F],X,Peligrosas):-		
		findall(Pos,
		(member(Pos,X),unSoloAdyacente(X,0,Pos),not(molinoFormado([S,M,F],Pos,1))),
		Peligrosas
		).

%quitarFicha(+,+,+) Quita una ficha del tablero
quitarFicha([Sf,Mf,If],Ficha,Jug):-
			quitarFichaTablero([Sf,Mf,If],Ficha,Jug,[Sr,Mr,Ir]),
				 retract(tablero(_S,_M,_I)),assertz(tablero(Sr,Mr,Ir)),
				 (Jug is 1 -> lista1(X) ; lista2(X)),
				 quita(Ficha,X,NuevaLista),
				 longitud(NuevaLista,Long),
				 (Jug is 1 ->
						retract(lista1(_X)),
						assertz(lista1(NuevaLista))					
					;
						retract(lista2(_X)),
						assertz(lista2(NuevaLista))						
					),
				(phase(1) ->   % estamos en la fase de mover piezas
					( Long < 3 ->
						assertz(juegoAcabado(true))
					;
						true)
				;
					true
				).

%compruebaMaqMolino(+,+,-,-) Comprueba si la maquina se ha hecho un molino y resuelve mediante buscaPeligrosas.
compruebaMaqMolino([Sf,Mf,If],Pos,Molino,Ficha):-
			lista1(X),
			(molinoFormado([Sf,Mf,If],Pos,2) ->
			 Molino is 1,
			 % buscar las fichas del jugador mas peligrosas			 
			 buscaPeligrosas([Sf,Mf,If],X,Lista),
			 longitud(Lista,Long),
			 (Long > 0 ->
				Sel is random(Long), iesimo(Ficha,Sel,Lista),%se selecciona una al azar entre las peligrosas
				quitarFicha([Sf,Mf,If],Ficha,1)
			 ;
				% de las fichas puestas solo podemos seleccionar las que no estn formando un molino
				findall(Pos1, (member(Pos1,X),not(molinoFormado([Sf,Mf,If],Pos1,1))),X1),
				longitud(X1,L),
				( L = 0 -> true % esto quiere decir que las fichas restantes estan formando un molino
				;
				Sel is random(L), iesimo(Ficha,Sel,X1),%se selecciona una al azar entre las que haya
				quitarFicha([Sf,Mf,If],Ficha,1)
			    )
			)
			 ;

			 Molino is 0
			 % no hemos hecho molino, continua el juego
			 ).

% mueveMaquina(+,+) Realiza el algoritmo minimax para determinar la jugada de la maquina.
mueveMaquina(NumPiezas,Prof):-
	tablero(S,M,I),
	(phase(1),jugadorBloqueado([S,M,I],2) -> assertz(juegoAcabado(true)), assertz(bloqueado(2))
	;
		(NumPiezas > 0 ->
			( % Poner piezas en la mejor posicin
				tablero(S,M,I),
				% Tablero, Jugador(mquina), Mejor Movimiento,
				lista1(X1), lista2(X2),
				minimax([S,M,I],(Pos1,_Pos2),_MejorValor,Prof,X1,X2),
				colocaFicha([S,M,I],Pos1,2,[Sf,Mf,If]),
				lista2(X),concatena(Pos1,X,Fichas1),
				retract(lista2(_X)),assertz(lista2(Fichas1)),
				retract(tablero(_S,_M,_I)),assertz(tablero(Sf,Mf,If)),
				% Si la mquina hace un molino buscar las fichas ms peligrosas del jugador
				compruebaMaqMolino([Sf,Mf,If],Pos1,Molino,Ficha)
			)
			;
			( % Mover una pieza a la mejor posicin
				tablero(S,M,I),
				% Tablero, Jugador(mquina), Mejor Movimiento,
				lista1(X1), lista2(X2),
				minimax([S,M,I],(Pos1,Pos2),_MejorValor,Prof,X1,X2),
				moverFicha([S,M,I],Pos1,Pos2,2),tablero(Sf2,Mf2,If2),
				compruebaMaqMolino([Sf2,Mf2,If2],Pos2,Molino,Ficha)
			)
		),
		dibujaTablero,
		(Molino == 1 ->
			write('La maquina ha hecho molino! Te ha quitado la ficha '),write(Ficha),nl
		;
			true
		)
	).

% escribePiezasRestantes(+) Escribe por consola el nmero de piezas restantes
escribePiezasRestantes(NumPiezas):-
	(NumPiezas > 0 ->
		write(NumPiezas),
		write(' piezas restantes'), nl
	;
		true
	).

% haTerminado Libera toda la memoria de la base de conocimeinto
haTerminado:-
	retractall(juegoAcabado(_)),
	retractall(tablero(_S,_M,_I)),
	retractall(fichas(_)),	
	lista1(L1),lista2(L2),
	longitud(L1,N1),longitud(L2,N2),
	(phase(1) ->
		( N1 < 3 -> write('Has perdido :('),nl ; true),
		( N2 < 3 -> write('Has ganado :)'),nl ; true),
		(bloqueado(1) -> write('Jugador bloqueado, has perdido :('),nl ; true),
		(bloqueado(2) -> write('Maquina bloqueada, has ganado :)'),nl ; true)
	;
		true),
	retractall(phase(_)),
	retractall(bloqueado(_)),retractall(lista1(_)),retractall(lista2(_)),
	write('Otra partida?(y/n)'),nl,
	read(Resp),
	( Resp = y -> molinero ;
	write('Bye bye!'),nl)
	.

	
% bucleJuego(+) Bucle principal del juego
bucleJuego(Dif):-
	fichas(NumPiezas),
	escribePiezasRestantes(NumPiezas),
        mueveJugador(NumPiezas),
	dibujaTablero,sleep(0.2),
	(not(juegoAcabado(true)) ->
		mueveMaquina(NumPiezas,Dif),
		% juegoTerminado -> juegoAcabado; bucleJuego,
		PiezasRestantes is NumPiezas -1,
		(PiezasRestantes > 0 ->		  
		  retract(fichas(NumPiezas)),
		  assert(fichas(PiezasRestantes))
		;
		  (phase(0) -> retract(fichas(NumPiezas)),assert(fichas(PiezasRestantes)),
			   retract(phase(_)),
			   assertz(phase(1))
		   ;
			   true
		   )
		),
		(juegoAcabado(true) -> haTerminado ; bucleJuego(Dif))
	;
		haTerminado)
	.

% dificultad(+) Se encarga de guardar la dificultad del juego
dificultad(Dif):-
		limpia, write('Selecciona la dificultad (facil,dificil):'),nl,
		read(Resp),
		(Resp = facil -> 
			Dif = 2
		;
			(Resp = dificil -> 
				Dif = 4
			;
				dificultad(Dif)
			)
		).
	
% molinero Llamada inicial a la aplicacion.
molinero:-
        % Inicializacin del juego
	assertz(tablero([0,0,0,0,0,0,0,0]    %Cuadrado exterior
        ,[0,0,0,0,0,0,0,0]            % Cuadrado intermedio
        ,[0,0,0,0,0,0,0,0])),		  % Cuadrado interior
	assertz(juegoAcabado(false)),
	assertz(fichas(9)), assertz(lista1([])), assertz(lista2([])),
	assertz(phase(0)),
	dificultad(Dif),
	dibujaTablero,
    bucleJuego(Dif).

movF(a). movF(b). movF(c). movF(d). movF(e). movF(f). movF(g). movF(h).
movF(i). movF(j). movF(k). movF(l). movF(m). movF(n). movF(o). movF(p).
movF(q). movF(r). movF(s). movF(t). movF(u). movF(v). movF(w). movF(x).

% devuelve todos los movimientos posibles como tuplas Pos1 Pos2 donde
% el movimiento va de Pos1 -> Pos2, en caso de ser el mismo es porque introducimos
% una nueva ficha en la funcin put
% moves(+,-,+)
moves(Tablero,Movimientos,MinOMax):-
	fichas(NumFichas),
	(NumFichas > 0 ->
	findall((Pos,Pos),
		(movF(Pos),tipoFicha(Tablero,Pos,0)),  % la posicion en la que se puede poner esta vacia.
	       Movimientos)
	;
	(MinOMax = min ->  % movimiento del rival, el jugador Jug = 1
			findall((Pos1,Pos2),
			  (movF(Pos1),tipoFicha(Tablero,Pos1,1),
			  movF(Pos2),tipoFicha(Tablero,Pos2,0),
			  sonAdyacentes(Pos1,Pos2)),  % la posicion en la que se puede poner esta vacia.
			   Movimientos)
			; % movimiento nuestro
			findall((Pos1,Pos2),
			  (movF(Pos1),tipoFicha(Tablero,Pos1,2),
			  movF(Pos2),tipoFicha(Tablero,Pos2,0),
			  sonAdyacentes(Pos1,Pos2)),  % la posicion en la que se puede poner esta vacia.
			   Movimientos)
		)
	)
	.

% devuelve en NuevoTablero el movimiento de posicionar la ficha en Pos1 en la
% posicin pos2, X1 es la lista de las fichas del jugador 1 y X2 del jugador 2
% put(+,+,+,+,+,-,-,-)
put(Tablero,(Pos1,Pos2),Ficha,X1,X2,NuevoTablero, NX1, NX2):-
	quitarFichaTablero(Tablero,Pos1,Ficha,TableroAux), % quitar ficha devuelve ture aunque la ficha quitada sea 0
	colocaFicha(TableroAux,Pos2,Ficha,TableroInter),
	(Ficha is 1 -> 
		quita(Pos1,X1,X1Aux), concatena(Pos2,X1Aux,NX1),
		(molinoFormado(TableroInter,Pos2,Ficha) ->
			buscaPeligrosas(TableroInter,X2,XList),longitud(XList,Long),
			(Long > 0 ->
				Sel is random(Long), %se selecciona una al azar entre las peligrosas
				iesimo(Pos,Sel,X2),quitarFichaTablero(TableroInter,Pos,2,NuevoTablero), quita(Pos,X2,NX2)
			;
				findall(Pos3, (member(Pos3,X2),not(molinoFormado(TableroInter,Pos3,2))),List),
				longitud(List,L),
				( L = 0 -> 
					NX2 = X2 % esto quiere decir que las fichas restantes estan formando un molino
				;
					Sel is random(L), iesimo(Pos,Sel,List),%se selecciona una al azar entre las que haya
					quitarFichaTablero(TableroInter,Pos,2,NuevoTablero), quita(Pos,X2,NX2)
				)
			)
		;
			NX2 = X2,
			NuevoTablero = TableroInter			
		)
	; %Ficha is 2
		quita(Pos1,X2,X2Aux), concatena(Pos2,X2Aux,NX2),
		(molinoFormado(TableroInter,Pos2,Ficha) ->
			buscaPeligrosas(TableroInter,X1,XList),longitud(XList,Long),
			(Long > 0 ->
				Sel is random(Long), %se selecciona una al azar entre las peligrosas
				iesimo(Pos,Sel,X1),quitarFichaTablero(TableroInter,Pos,1,NuevoTablero), quita(Pos,X1,NX1)
			;
				findall(Pos3, (member(Pos3,X1),not(molinoFormado(TableroInter,Pos3,1))),List),
				longitud(List,L),
				( L = 0 -> 
					NX1 = X1 % esto quiere decir que las fichas restantes estan formando un molino
				;
					Sel is random(L), iesimo(Pos,Sel,List),%se selecciona una al azar entre las que haya
					quitarFichaTablero(TableroInter,Pos,1,NuevoTablero), quita(Pos,X1,NX1)
				)
			)
		;
			NX1 = X1,
			NuevoTablero = TableroInter			
		)
	)
	.
	
% Saca por el segundo parametro las posiciones adyacentes a la posicion pasada por e primer argumento
% adyacente(+,-)
adyacente(Pos1,Pos2):- % (+Pos1,-Pos2)
	X = Pos1,
	(
	X = a, Pos2 = [b,h];
	X = b, Pos2 = [a,c,j];
	X = c, Pos2 = [b,d];
	X = d, Pos2 = [c,e,l];
	X = e, Pos2 = [d,f];
	X = f, Pos2 = [e,g,n];
	X = g, Pos2 = [f,h];
	X = h, Pos2 = [a,g,p];
	X = i, Pos2 = [p,j];
	X = j, Pos2 = [b,i,k,r];
	X = k, Pos2 = [j,l];
	X = l, Pos2 = [d,k,m,t];
	X = m, Pos2 = [l,n];
	X = n, Pos2 = [f,m,o,v];
	X = o, Pos2 = [n,p];
	X = p, Pos2 = [h,i,o,x];
	X = q, Pos2 = [r,x];
	X = r, Pos2 = [q,s,j];
	X = s, Pos2 = [r,t];
	X = t, Pos2 = [l,s,u];
	X = u, Pos2 = [t,v];
	X = v, Pos2 = [n,u,w];
	X = w, Pos2 = [v,x];
	X = x, Pos2 = [p,q,w];
	false ) -> true ; false.

% sonAdyacentes(+,-) Devuelve una posicin adyacente al primer parametro
sonAdyacentes(Pos1,Pos2):- % (+Pos1,-Pos2)
	adyacente(Pos1,Lista),
	member(Pos2,Lista).

% Estar bloqueada si las posiciones adyacentes estn ocupadas
% fichaBloqueada(+,+)
fichaBloqueada(Tablero,Pos1) :-
	adyacente(Pos1,Lista),
	todasOcupadas(Tablero,Lista).

% Acierta si todas las fichas de la lista del segundo parametro estn ocupadas por fichas	
% todasOcupadas(+,+) 
todasOcupadas(_Tablero,[]).

todasOcupadas(Tablero,[X|Xs]):-
	(tipoFicha(Tablero,X,1) | tipoFicha(Tablero,X,2)),
	todasOcupadas(Tablero,Xs).

% bloqueadas(+,+) Acierta si las fichas pasadas por segundo parametro estan bloqueadas
bloqueadas(_Tablero, []).

bloqueadas(Tablero, [X|Xs]):-
	fichaBloqueada(Tablero,X),
	bloqueadas(Tablero,Xs).

% jugadorBloqueado(+,+) Acierta si el jugador pasado por parametro est bloqueado
jugadorBloqueado(Tablero,Jug):-
	(Jug = 1 ->
	 lista1(Lista)
	 ;
	 lista2(Lista)
	),
	longitud(Lista, Long),
	(Long > 0 ->
		bloqueadas(Tablero,Lista)
	;
		false
	).

% rival(+,-) Saca por el segundo parametro quien es el rival del primero
rival(Player,Rival):-
	(Player = 2 -> Rival = 1
		;
		Rival = 2
	).
	
% rivalBloqueado(+,+) Acierta si el rival esta bloqueado
rivalBloqueado(Board, Player):-
	rival(Player,Rival),
	jugadorBloqueado(Board,Rival).
	
% rivalSinFichas(+,+) Acierta si el rival no tiene fichas suficientes
rivalSinFichas(Player):-
	(phase(1) ->
		rival(Player,Rival),
		( Rival = 1 ->
			lista1(L1),longitud(L1,N1),
			N1 < 3
			;
			lista2(L2),
			longitud(L2,N2),
			N2 < 3
		)
	;
		false
	).

% molinoFormado(+,+,+) Acierta si se est haciendo un molino con la ficha Jug en la posicion Movida
molinoFormado(Board,Movida,Jug):-
	X = Movida,
	(
	X = a, ((tipoFicha(Board,b,Jug),tipoFicha(Board,c,Jug)) | (tipoFicha(Board,h,Jug),tipoFicha(Board,g,Jug)));
	X = b, ((tipoFicha(Board,a,Jug),tipoFicha(Board,c,Jug)) | (tipoFicha(Board,j,Jug),tipoFicha(Board,r,Jug)));
	X = c, ((tipoFicha(Board,a,Jug),tipoFicha(Board,b,Jug)) | (tipoFicha(Board,d,Jug),tipoFicha(Board,e,Jug)));
	X = d, ((tipoFicha(Board,c,Jug),tipoFicha(Board,e,Jug)) | (tipoFicha(Board,t,Jug),tipoFicha(Board,l,Jug)));
	X = e, ((tipoFicha(Board,c,Jug),tipoFicha(Board,d,Jug)) | (tipoFicha(Board,f,Jug),tipoFicha(Board,g,Jug)));
	X = f, ((tipoFicha(Board,g,Jug),tipoFicha(Board,e,Jug)) | (tipoFicha(Board,v,Jug),tipoFicha(Board,n,Jug)));
	X = g, ((tipoFicha(Board,f,Jug),tipoFicha(Board,e,Jug)) | (tipoFicha(Board,a,Jug),tipoFicha(Board,h,Jug)));
	X = h, ((tipoFicha(Board,a,Jug),tipoFicha(Board,g,Jug)) | (tipoFicha(Board,p,Jug),tipoFicha(Board,x,Jug)));
	X = i, ((tipoFicha(Board,j,Jug),tipoFicha(Board,k,Jug)) | (tipoFicha(Board,p,Jug),tipoFicha(Board,o,Jug)));
	X = j, ((tipoFicha(Board,b,Jug),tipoFicha(Board,r,Jug)) | (tipoFicha(Board,i,Jug),tipoFicha(Board,k,Jug)));
	X = k, ((tipoFicha(Board,i,Jug),tipoFicha(Board,j,Jug)) | (tipoFicha(Board,l,Jug),tipoFicha(Board,m,Jug)));
	X = l, ((tipoFicha(Board,k,Jug),tipoFicha(Board,m,Jug)) | (tipoFicha(Board,d,Jug),tipoFicha(Board,t,Jug)));
	X = m, ((tipoFicha(Board,k,Jug),tipoFicha(Board,l,Jug)) | (tipoFicha(Board,o,Jug),tipoFicha(Board,n,Jug)));
	X = n, ((tipoFicha(Board,o,Jug),tipoFicha(Board,m,Jug)) | (tipoFicha(Board,v,Jug),tipoFicha(Board,f,Jug)));
	X = o, ((tipoFicha(Board,i,Jug),tipoFicha(Board,p,Jug)) | (tipoFicha(Board,n,Jug),tipoFicha(Board,m,Jug)));
	X = p, ((tipoFicha(Board,i,Jug),tipoFicha(Board,o,Jug)) | (tipoFicha(Board,h,Jug),tipoFicha(Board,x,Jug)));
	X = q, ((tipoFicha(Board,r,Jug),tipoFicha(Board,s,Jug)) | (tipoFicha(Board,x,Jug),tipoFicha(Board,w,Jug)));
	X = r, ((tipoFicha(Board,q,Jug),tipoFicha(Board,s,Jug)) | (tipoFicha(Board,b,Jug),tipoFicha(Board,j,Jug)));
	X = s, ((tipoFicha(Board,q,Jug),tipoFicha(Board,r,Jug)) | (tipoFicha(Board,t,Jug),tipoFicha(Board,u,Jug)));
	X = t, ((tipoFicha(Board,s,Jug),tipoFicha(Board,u,Jug)) | (tipoFicha(Board,l,Jug),tipoFicha(Board,d,Jug)));
	X = u, ((tipoFicha(Board,s,Jug),tipoFicha(Board,t,Jug)) | (tipoFicha(Board,v,Jug),tipoFicha(Board,w,Jug)));
	X = v, ((tipoFicha(Board,u,Jug),tipoFicha(Board,w,Jug)) | (tipoFicha(Board,n,Jug),tipoFicha(Board,f,Jug)));
	X = w, ((tipoFicha(Board,v,Jug),tipoFicha(Board,u,Jug)) | (tipoFicha(Board,q,Jug),tipoFicha(Board,x,Jug)));
	X = x, ((tipoFicha(Board,q,Jug),tipoFicha(Board,w,Jug)) | (tipoFicha(Board,h,Jug),tipoFicha(Board,p,Jug)));
	false ) -> true ; false.

	
%% Mtodos para la heurstica

% encuentra(+,+,+) Acierta si encuentra una ficha del tipo Player en las posiciones de la lista
encuentra(Board,Player,[X|Xs]):-
(
	tipoFicha(Board,X,Player) -> 
		true
	;
	encuentra(Board,Player,Xs)
).

% fichaEnExterior(+,+) Acierta si hay una ficha en el cuadrado exterior
fichaEnExterior(Board,Player):-
	encuentra(Board,Player,[a,b,c,d,e,f,g,h]).

% fichaEnMedio(+,+) Acierta si hay una ficha en el cuadrado medio
fichaEnMedio(Board,Player):-
	encuentra(Board,Player,[i,j,k,l,m,n,o,p]).
	
% fichaEnInterior(+,+) Acierta si hay una ficha en el cuadrado interior
fichaEnInterior(Board,Player):-
	encuentra(Board,Player,[q,r,s,t,u,v,w,x]).

% unaFichaEnCadaNivel(+,+) Acierta si hay una ficha en cada nivel del tipo Player
unaFichaEnCadaNivel(Board,Player):-
	fichaEnExterior(Board,Player),
	fichaEnMedio(Board,Player),
	fichaEnInterior(Board,Player).

% fichasEnPuntosMedios(+,+,-) Devuelve en el tercer parametro el numero de fichas en puntos medios
fichasEnPuntosMedios(Board,Player,N):-
	cuantasMias(Board,Player,[p,j,l,n],0,N).

% cuantasMias(+,+,+,-) Devuelve en el cuarto parametro cuantas fichas de tipo Player hay en la lista
cuantasMias(_Board,_Player,[],M,N):-
	N = M.
	
cuantasMias(Board,Player,[X|Xs],M,N):-
	(
	tipoFicha(Board,X,Player) -> 
		cuantasMias(Board,Player,Xs,M+1,N)
	;
		cuantasMias(Board,Player,Xs,M,N)
	).
